function trim(s,  t)
{
	t = s
	sub(/^[ \t]+/,"",t)
	sub(/[ \t]+$/,"",t)
	return t
}

function asm_text(s) {
	print s > Output_file
}
function bas_text(s) {
	print s > BAS_Output_file
}


BEGIN {
	Output_file = "bascompi.asm"
	BAS_Output_file = "bascompi_orz.bas"
	Reg_file = "\"tn2313def.inc\""
	CPU_Clock = 1000000
}

/\$regfile/ {
	if (NF == 1) {
		Reg_file = substr($1,10)
	} else if (NF == 3) {
		Reg_file = $3
	}
}

/\$crystal/ {
	if (NF == 1) {
		CPU_Clock = substr($1,10)
	} else if (NF == 3) {
		CPU_Clock = $3
	}
}

/pinD/ {
	if ($2 ~/pinD\.[0123456]=[01]/) {
		pin = substr($2,6,1)
		val = substr($2,8,1)
	}
}

/(Sound|sound)/ {
	port_s = substr($2,1,7)
	port_s = toupper(substr(port_s,1,1))tolower(substr(port_s,2))
	sound_s = "Sound "port_s",wt1,a"
	sound_flag = 1
}

/^(Data|data) / {
	flag = 1
	i = index($0,$1)
	s = substr($0,i+5)
	n = split(s,dd,",")
	for (i = 1; i <= n; i++) {
		ddi = trim(dd[i])
		if (ddi) {
			if (ddi ~ /^("[_+-][ABCDEFGK][_#b][012346][123468]"|[0-9]?[0-9][0-9]|"XXXXX")$/) {
				flag = flag * 1
			} else {
				flag = flag * 0
			}
			orgel_data[j++] = ddi
		}
	}
	data_flag = flag
}

END {
	if (sound_flag && data_flag) {
		exit_code = 21
	} else {
		exit exit_code
	}

#	print "Reg_file = "Reg_file
	if (tolower(Reg_file) == "\"tn2313def.inc\"") {
	} else if (tolower(Reg_file) == "\"m168def.dat\"") {
		bas_text("$regfile = "Reg_file)
	}

#	print "CPU_Clock = "CPU_Clock
	if (CPU_Clock == 1000000) {
	} else if (CPU_Clock == 12000000) {
		bas_text("$crystal = "CPU_Clock)
	}

	data_oct[0] = 640
	data_oct[1] = 320
	data_oct[2] = 160
	data_oct[3] = 80
	data_oct[4] = 40
	data_oct[5] = 20
	data_oct[6] = 10

	data_freq[1] = 33228
	data_freq[2] = 35200
	data_freq[3] = 37296
	data_freq[4] = 39511
	data_freq[5] = 0
	data_freq[6] = 20930
	data_freq[7] = 22175
	data_freq[8] = 23493
	data_freq[9] = 24890
	data_freq[10] = 26370
	data_freq[11] = 0
	data_freq[12] = 27938
	data_freq[13] = 29600
	data_freq[14] = 31360
	data_freq[15] = 33224

	n = split("64 48 32 24 16 12 08 06 04 03 02 01",oncho)
	for (i = 1; i <= n; i++) {
		oncho_s[oncho[i]] = 64/(oncho[i]+0)""
	}
	n = split(" V h  ~ t@ \",onmei)
	onmei[0] = "x"

#	asm_text(".include \"tn2313def.inc\"")
#	asm_text("")
	bas_text("do")
	bas_text("    waitms 100")

	if (pin == "") {
		bas_text("    gosub bbb")
	} else {
		bas_text("    if pinD."pin"="val" then")
		bas_text("        gosub bbb")
		bas_text("    end if")
	}

	bas_text("loop")
	bas_text("end")
	bas_text("")
	bas_text("bbb:")
	bas_text("restore aaa")
	bas_text("do")
	bas_text("    waitms 30")
	bas_text("    read a")
	bas_text("    if a=0 then")
	bas_text("        exit do")
	bas_text("    end if")
	bas_text("    wt1=a")
	bas_text("    read a")
	bas_text("    if a=0 then")
	bas_text("        waitms wt1")
	bas_text("    else")

	bas_text("        "sound_s)

	bas_text("    end if")
	bas_text("loop")
	bas_text("return")
	bas_text("")
	bas_text("aaa:")

	tempo = orgel_data[0]
	mtempo = int(4800/tempo)
	for (i = 1; i < j - 1; i++) {
		ddi = substr(orgel_data[i],2,5)
		onmei_e = substr(ddi,2,1)
		kigo = substr(ddi,3,1)
		oncho_e = substr(ddi,4)
		if (substr(oncho_e,1,1) == "0") {
			oncho_e = substr(oncho_e,2)
		}
		ddi1 = substr(ddi,1,1)
		ddi2 = substr(ddi,1,2)
		sub(/_/," ",ddi2)
		ddi3 = substr(ddi,3,1)
		sub(/_/,"",ddi3)
		ddi4 = substr(ddi,4)
		oct = 4
		if (ddi1 == "+") {
			oct = 5
		} else if (ddi1 == "-") {
			oct = 3
		}

		octa = data_oct[oct]
		onkai = index("ABCDEFG",onmei_e)*2
		if (kigo=="#") {
			onkai++
		}
		if (kigo=="b") {
			onkai--
		}
		freq = data_freq[onkai]
		wt1 = int(mtempo*ddi4*int(freq/octa)/1000)
		aa = int(freq/octa)
		if (aa == 0) {
			wt1 = mtempo*ddi4
			wt2 = 0
		} else {
			wt2 = int(CPU_Clock/(int(freq/octa)*12))
		}
#		print ddi ": "ddi2 ddi3 " ("onmei[index("ABCDEFG",onmei_e)]")" (ddi4=="64"?"S":oncho_s[ddi4])  ","freq ","wt1","wt2
#		asm_text(".dw "wt1","wt2)
		bas_text("Data "wt1"%,"wt2"%")
	}
	bas_text("Data 0%,0%")
	exit exit_code
}
